--- tdesktop-2.7.4-full.orig/Telegram/lib_webview/CMakeLists.txt
+++ tdesktop-2.7.4-full/Telegram/lib_webview/CMakeLists.txt
@@ -116,7 +116,7 @@
         desktop-app::lib_webview_winrt
     )
 elseif (LINUX)
-    if (NOT DESKTOP_APP_DISABLE_GTK_INTEGRATION)
+    if (NOT DESKTOP_APP_DISABLE_WEBKIT)
         find_package(PkgConfig REQUIRED)
 
         if (DESKTOP_APP_USE_PACKAGED AND NOT DESKTOP_APP_USE_PACKAGED_LAZY)
--- tdesktop-2.7.4-full.orig/Telegram/lib_webview/webview/platform/linux/webview_linux.cpp
+++ tdesktop-2.7.4-full/Telegram/lib_webview/webview/platform/linux/webview_linux.cpp
@@ -11,14 +11,14 @@
 namespace Webview {
 
 Available Availability() {
-#ifndef DESKTOP_APP_DISABLE_GTK_INTEGRATION
+#ifndef DESKTOP_APP_DISABLE_WEBKIT
 	return WebKit2Gtk::Availability();
-#else // !DESKTOP_APP_DISABLE_GTK_INTEGRATION
+#else // !DESKTOP_APP_DISABLE_WEBKIT
 	return Available{
 		.error = Available::Error::NoGtkOrWebkit2Gtk,
 		.details = "This feature was disabled at build time.",
 	};
-#endif // DESKTOP_APP_DISABLE_GTK_INTEGRATION
+#endif // DESKTOP_APP_DISABLE_WEBKIT
 }
 
 bool SupportsEmbedAfterCreate() {
@@ -26,11 +26,11 @@
 }
 
 std::unique_ptr<Interface> CreateInstance(Config config) {
-#ifndef DESKTOP_APP_DISABLE_GTK_INTEGRATION
+#ifndef DESKTOP_APP_DISABLE_WEBKIT
 	return WebKit2Gtk::CreateInstance(std::move(config));
-#else // !DESKTOP_APP_DISABLE_GTK_INTEGRATION
+#else // !DESKTOP_APP_DISABLE_WEBKIT
 	return nullptr;
-#endif // DESKTOP_APP_DISABLE_GTK_INTEGRATION
+#endif // DESKTOP_APP_DISABLE_WEBKIT
 }
 
 } // namespace Webview
--- tdesktop-2.7.4-full.orig/cmake/options.cmake
+++ tdesktop-2.7.4-full/cmake/options.cmake
@@ -49,6 +49,13 @@
     )
 endif()
 
+if (DESKTOP_APP_DISABLE_WEBKIT)
+    target_compile_definitions(common_options
+    INTERFACE
+        DESKTOP_APP_DISABLE_WEBKIT
+    )
+endif()
+
 if (DESKTOP_APP_USE_PACKAGED)
     target_compile_definitions(common_options
     INTERFACE
--- tdesktop-2.7.4-full.orig/cmake/variables.cmake
+++ tdesktop-2.7.4-full/cmake/variables.cmake
@@ -38,6 +38,7 @@
 option(DESKTOP_APP_USE_PACKAGED_LAZY_PLATFORMTHEMES "Bundle recommended Qt platform themes for self-contained packages. (Linux only)" ${DESKTOP_APP_USE_PACKAGED_LAZY})
 option(DESKTOP_APP_USE_PACKAGED_FFMPEG_STATIC "Link ffmpeg statically in packaged mode." OFF)
 option(DESKTOP_APP_DISABLE_SPELLCHECK "Disable spellcheck library." ${osx_special_target})
+option(DESKTOP_APP_DISABLE_WEBKIT "Disable WebkitGTK library (Linux only)." OFF)
 option(DESKTOP_APP_DISABLE_CRASH_REPORTS "Disable crash report generation." ${no_special_target})
 option(DESKTOP_APP_DISABLE_AUTOUPDATE "Disable autoupdate." ${disable_autoupdate})
 option(DESKTOP_APP_USE_HUNSPELL_ONLY "Disable system spellchecker and use bundled Hunspell only. (For debugging purposes)" OFF)