--- tdesktop-2.7.4-full.orig/Telegram/lib_webview/webview/platform/linux/webview_linux_webkit_gtk.cpp
+++ tdesktop-2.7.4-full/Telegram/lib_webview/webview/platform/linux/webview_linux_webkit_gtk.cpp
@@ -6,6 +6,7 @@
 //
 #include "webview/platform/linux/webview_linux_webkit_gtk.h"
 
+#include "base/optional.h"
 #include "base/platform/linux/base_linux_gtk_integration.h"
 #include "base/platform/linux/base_linux_gtk_integration_p.h"
 
--- tdesktop-2.7.4-full.orig/Telegram/lib_webview/webview/webview_embed.cpp
+++ tdesktop-2.7.4-full/Telegram/lib_webview/webview/webview_embed.cpp
@@ -14,7 +14,6 @@
 
 #include <QtWidgets/QWidget>
 #include <QtGui/QWindow>
-#include <QtCore/QJsonDocument>
 
 namespace Webview {
 namespace {
--- tdesktop-2.7.4-full.orig/Telegram/lib_webview/webview/webview_embed.h
+++ tdesktop-2.7.4-full/Telegram/lib_webview/webview/webview_embed.h
@@ -9,6 +9,8 @@
 #include "base/unique_qptr.h"
 #include "base/basic_types.h"
 
+#include <QtCore/QJsonDocument>
+
 class QString;
 class QWidget;
 class QWindow;