Only link jemalloc for the Telegram binary

Some combination of factors is making the different codegen tools hang when
jemalloc is linked for those, and they're ran under portage's sandbox. Since
this is only used during build-time, and jemalloc is merely necessary to
improve runtime memory use, it's unnecessary to use it for anything else.

--- tdesktop-2.8.10-full.orig/Telegram/CMakeLists.txt
+++ tdesktop-2.8.10-full/Telegram/CMakeLists.txt
@@ -87,6 +87,7 @@
     PRIVATE
         desktop-app::external_glibmm
         desktop-app::external_glib
+        desktop-app::external_jemalloc
     )
 
     if (NOT DESKTOP_APP_DISABLE_DBUS_INTEGRATION)
--- tdesktop-2.8.10-full.orig/cmake/options_linux.cmake
+++ tdesktop-2.8.10-full/cmake/options_linux.cmake
@@ -58,11 +58,6 @@
     endif()
 endif()
 
-target_link_libraries(common_options
-INTERFACE
-    desktop-app::external_jemalloc
-)
-
 if (DESKTOP_APP_USE_PACKAGED)
     find_library(ATOMIC_LIBRARY atomic)
 else()